//----------------------------------------------------------
//-------  Parameter-less SGA		            ------------
//-------  - Single SGA definitions		    ------------
//----------------------------------------------------------

# ifndef GENERATION_SGA_H
# define GENERATION_SGA_H

//------- Initializes population with a given index popId that impies the population size, crossover rate 
//------- and the tournament selection parameter.
//------- Returns 1 if the initialization went OK; otherwise returns 0.
int initPopulation(int popId, int *evals);

//------- Destroys population with given index popId
void destroyPopulation(int popId);

//------- Shifts population popId to the left and resets all population's records at the position popId
void shiftPopulationToLeft(int popId);

//------- Performs one generation with the population popId
void doGeneration(int popId, int *evals);

//------- Checks the populations whether the relation favg(i)>=favg(i+1) for all i=1...nSGA-1 
//------- Returns the index of the largest population 'i' for which the relation favg(i)>=favg(i+1) does not hold.
//------- Otherwise, returns -1.
int checkAverageFitness(tstat *statdata);

//------- Checks the convergence rate of given population
//------- Returns 1 if the population has completely converged; otherwise returns 0.
int checkConvergence(int popId);


# endif